package com.example.delivery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.stream.annotation.StreamListener;
import org.springframework.messaging.handler.annotation.Payload;
import org.springframework.stereotype.Service;

@Service
public class EventHandler {
    @Autowired DeliveryRepository deliveryRepository;

    @StreamListener(StreamProcessor.INPUT)
    public void onOrderChanged_startDelivery(@Payload OrderPlaced orderPlaced){


        if(orderPlaced.isMe()){
            System.out.println("##### listener StartDelivery : " + orderPlaced.toJson());
            Delivery delivery = new Delivery();
            delivery.setOrderId(orderPlaced.getId());
            delivery.setProductId(orderPlaced.getProductId());
            delivery.setProductName(orderPlaced.getProductName());
            delivery.setUserId(orderPlaced.getUserId());
            deliveryRepository.save(delivery);
        }
    }
}
